// Generated by CoffeeScript 1.6.3
(function() {
  var expandAndMergeRules, exports, flattenCss, fs, generateRuleStr, indentation, log, mergeDeclarations, parse, printRule, util, _;

  fs = require('fs');

  util = require('util');

  parse = require('css-parse');

  _ = require('underscore');

  indentation = '  ';

  log = function(obj) {
    return console.log(util.inspect(obj, {
      depth: 10
    }));
  };

  mergeDeclarations = function(declarations1, declarations2) {
    var decl, hash, ret, _i, _j, _len, _len1;
    hash = {};
    for (_i = 0, _len = declarations2.length; _i < _len; _i++) {
      decl = declarations2[_i];
      hash[decl.property] = decl;
    }
    ret = [];
    for (_j = 0, _len1 = declarations1.length; _j < _len1; _j++) {
      decl = declarations1[_j];
      if (!hash[decl.property]) {
        ret.push(decl);
      }
    }
    ret = ret.concat(declarations2);
    return _(ret).sortBy(function(decl) {
      return decl.property;
    });
  };

  printRule = function(rule, indentation) {
    var decl, _i, _len, _ref;
    console.log("\n" + rule.selector + " {");
    _ref = rule.declarations;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      decl = _ref[_i];
      console.log("" + indentation + decl.property + ": " + decl.value + ";");
    }
    return console.log('};');
  };

  generateRuleStr = function(rule, indentation) {
    var decl, ret, _i, _len, _ref;
    ret = "" + rule.selector + " {\n";
    _ref = rule.declarations;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      decl = _ref[_i];
      ret += "" + indentation + decl.property + ": " + decl.value + ";\n";
    }
    return ret += '}\n';
  };

  expandAndMergeRules = function(node) {
    var declarations, ret, rule, rules, selector, selectors, _i, _j, _len, _len1;
    rules = node.stylesheet.rules;
    ret = {};
    for (_i = 0, _len = rules.length; _i < _len; _i++) {
      rule = rules[_i];
      if (!(rule.type === 'rule')) {
        continue;
      }
      selectors = rule.selectors;
      for (_j = 0, _len1 = selectors.length; _j < _len1; _j++) {
        selector = selectors[_j];
        selector = selector.trim();
        if (!ret[selector]) {
          declarations = _.clone(rule.declarations);
          ret[selector] = _.extend({}, {
            selector: selector,
            declarations: declarations
          });
        } else {
          declarations = mergeDeclarations(ret[selector].declarations, rule.declarations);
          ret[selector].declarations = declarations;
        }
      }
    }
    rules = _.values(ret);
    return _.sortBy(rules, function(decl) {
      return decl.selector;
    });
  };

  module.exports = exports = flattenCss = function(cssStr, indentation) {
    var node, rule, rules, str, _i, _len;
    node = parse(cssStr);
    rules = expandAndMergeRules(node);
    str = '';
    for (_i = 0, _len = rules.length; _i < _len; _i++) {
      rule = rules[_i];
      str += generateRuleStr(rule, indentation);
    }
    return str;
  };

}).call(this);
